
/*
 * nqueens.h - Global header file for the parallel version of N Queens
 * (c) Paulo Marques, pmarques@dei.uc.pt
 * April 03, 2003
 */

#ifndef _NQUEENS_H_
#define _NQUEENS_H_

/******************************/

// Uncomment the following line for printing the solutions
// #define PRINT_SOLUTIONS                    

/******************************/

extern int id;                              // The id of the current process
extern int granularity;                     // Granularity of the jobs
extern int size;                            // The size of the problem (size x size)
extern int n_workers;                       // Total number of workers running

/******************************/

extern void print_solution(int board[], int size);
extern int  master();
extern void worker();

/******************************/

#define MAX_SIZE        			    20				// Max problem size
#define DEFAULT_SIZE              10        // Default board size
#define DEFAULT_GRANULARITY       2         // Default granularity

#define MASTER            0					        // The master is process 0

/******************************/


//-------- JOB Related structures
#define QUIT				  0					             // Message to quit
#define DO_WORK				1					             // Message to do the work

typedef struct
{
	int type;									                 // QUIT / DO_WORK
  int board[MAX_SIZE];  					           // The job to process
} job;
//--------

//-------- Message sent by workers
#define SOLUTION			0					             // A solution found by a worker
#define REQUEST_WORK	1					             // A worker requesting a job

typedef struct
{
	int origin; 								               // The id of the worker who sent the msg
  int solutions_found;                       // Number of solutions found
} worker_msg;
//--------

#endif
