using System;
using System.Net;
using System.Xml.Serialization;
using com.trcinc.security.ws;
using com.trcinc.finance.ws;

public class FinanceServiceClient 
{

	private CookieContainer cookies;
	private SecurityServiceWebServiceService securityService;
	private FinanceServiceWebServiceService financeService;
	private SecureSession secureSession;

	public FinanceServiceClient ()
	{
			cookies = new CookieContainer();
	
			securityService = new SecurityServiceWebServiceService();
			financeService = new FinanceServiceWebServiceService();
			
			securityService.CookieContainer = cookies;
			financeService.CookieContainer = cookies;
	}
	
	
	
	public void login ()
	{
			Console.WriteLine ("*** login ***");
			secureSession = securityService.login ("testuser", "password");
	}
	
	public double getStockQuote (string ticker)
	{
			Console.WriteLine ("*** getStockQuote (" + ticker + ") ***");
			return financeService.getStockQuote (ticker);
	}
	
	
	public void logout ()
	{
			Console.WriteLine ("*** logout ***");			
	
			securityService.logout (secureSession);
	}
	
	
}	
