using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace FinanceServiceGUI
{

	public class FinanceServiceGUI
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new LoginForm());
		}
	}

	/// <summary>
	/// Summary description for LoginForm.
	/// </summary>
	public class LoginForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label UserNameLabel;
		private System.Windows.Forms.TextBox UserNameText;
		private System.Windows.Forms.Label PasswordLabel;
		private System.Windows.Forms.TextBox PasswordText;
		private System.Windows.Forms.Button Login;
		private System.Windows.Forms.TextBox Status;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		private FinanceServiceClient fsc;

		public LoginForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
			this.fsc = new FinanceServiceClient ();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.UserNameLabel = new System.Windows.Forms.Label();
			this.UserNameText = new System.Windows.Forms.TextBox();
			this.PasswordLabel = new System.Windows.Forms.Label();
			this.PasswordText = new System.Windows.Forms.TextBox();
			this.Login = new System.Windows.Forms.Button();
			this.Status = new System.Windows.Forms.TextBox();
			
			this.SuspendLayout();
			// 
			// User name label
			// 
			this.UserNameLabel.Location = new System.Drawing.Point(44, 16);
			this.UserNameLabel.Name = "SymbolLabel";
			this.UserNameLabel.Size = new System.Drawing.Size(96, 32);
			this.UserNameLabel.TabIndex = 0;
			this.UserNameLabel.Text = "User name:";
			// 
			// User name text box
			// 
			this.UserNameText.Location = new System.Drawing.Point(140, 16);
			this.UserNameText.Name = "UserNameText";
			this.UserNameText.Size = new System.Drawing.Size(96, 16);
			this.UserNameText.TabIndex = 1;
			this.UserNameText.Text = "testuser";

			// 
			// Password label
			// 
			this.PasswordLabel.Location = new System.Drawing.Point(44, 80);
			this.PasswordLabel.Name = "PasswordLabel";
			this.PasswordLabel.Size = new System.Drawing.Size(96, 16);
			this.PasswordLabel.TabIndex = 0;
			this.PasswordLabel.Text = "Password:";
			// 
			// Password text box
			// 
			this.PasswordText.Location = new System.Drawing.Point(140, 80);
			this.PasswordText.Name = "PasswordText";
			this.PasswordText.Size = new System.Drawing.Size(96, 16);
			this.PasswordText.TabIndex = 5;
			this.PasswordText.Text = "password";
			this.PasswordText.PasswordChar = '*';


			// 
			// Login button
			// 
			this.Login.Location = new System.Drawing.Point(140, 130);
			this.Login.Name = "Login";
			this.Login.Size = new System.Drawing.Size(80, 24);
			this.Login.TabIndex = 2;
			this.Login.Text = "Login";
			this.Login.Click += new System.EventHandler(this.Login_Click);
			this.Login.Enabled = true;

			// 
			// status text box
			// 
			this.Status.Location = new System.Drawing.Point(12, 170);
			this.Status.Multiline = false;
			this.PasswordText.Name = "PasswordText";
			this.Status.Size = new System.Drawing.Size(370, 16);
			this.Status.TabIndex = 5;
			this.Status.Text = "";
			this.Status.Enabled = false;
			
			// 
			// Form
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 200);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.UserNameLabel,
																		  this.UserNameText,
																		  this.PasswordLabel,
																		  this.PasswordText,
																		  this.Login,
																		  this.Status
																		  });
			this.Name = "FinanceService:LoginForm";
			this.Text = "FinanceService:LoginForm";
			this.ResumeLayout(false);

		}
		#endregion


		private void Login_Click(object sender, System.EventArgs e)
		{
			try
			{
			
				this.fsc.login ();
				
				this.Hide ();
				StockQuoteForm QuoteForm = new StockQuoteForm (fsc);
				
				
			 QuoteForm.ShowDialog(this);
			 
			 QuoteForm.Dispose();
			 
			 
			 this.Close ();
				
			}
			catch (SystemException ex)
			{
				this.Status.Text = ex.Message;
				Console.WriteLine ("*** exceptin: " + ex.ToString ());
			}
			
		}

	}
	
	/// <summary>
	/// Summary description for StockQuoteForm.
	/// </summary>
	public class StockQuoteForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label TickerLabel;
		private System.Windows.Forms.TextBox TickerSymbol;
		private System.Windows.Forms.Label ResultLabel;
		private System.Windows.Forms.TextBox Results;
		private System.Windows.Forms.Button Submit;
		private System.Windows.Forms.TextBox Status;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		private FinanceServiceClient fsc;

		public StockQuoteForm(FinanceServiceClient fsc)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
			this.fsc = fsc;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.TickerLabel = new System.Windows.Forms.Label();
			this.TickerSymbol = new System.Windows.Forms.TextBox();
			this.ResultLabel = new System.Windows.Forms.Label();
			this.Results = new System.Windows.Forms.TextBox();
			this.Submit = new System.Windows.Forms.Button();
			this.Status = new System.Windows.Forms.TextBox();
			
			this.SuspendLayout();
			// 
			// Ticker Symbol label
			// 
			this.TickerLabel.Location = new System.Drawing.Point(44, 16);
			this.TickerLabel.Name = "SymbolLabel";
			this.TickerLabel.Size = new System.Drawing.Size(96, 32);
			this.TickerLabel.TabIndex = 0;
			this.TickerLabel.Text = "Enter Symbol (QQQ/DIA):";
			// 
			// Ticker Symbol text box
			// 
			this.TickerSymbol.Location = new System.Drawing.Point(140, 16);
			this.TickerSymbol.Name = "TickerSymbol";
			this.TickerSymbol.Size = new System.Drawing.Size(96, 16);
			this.TickerSymbol.TabIndex = 1;
			this.TickerSymbol.Text = "QQQ";

			// 
			// Results label
			// 
			this.ResultLabel.Location = new System.Drawing.Point(44, 80);
			this.ResultLabel.Name = "ResultLabel";
			this.ResultLabel.Size = new System.Drawing.Size(96, 16);
			this.ResultLabel.TabIndex = 0;
			this.ResultLabel.Text = "Stock Price:";
			// 
			// Results text box
			// 
			this.Results.Location = new System.Drawing.Point(140, 80);
			this.Results.Name = "Results";
			this.Results.Size = new System.Drawing.Size(96, 16);
			this.Results.TabIndex = 5;
			this.Results.Text = "";
			this.Results.Enabled = false;

			// 
			// Submit
			// 
			this.Submit.Location = new System.Drawing.Point(140, 130);
			this.Submit.Name = "Submit";
			this.Submit.Size = new System.Drawing.Size(80, 24);
			this.Submit.TabIndex = 2;
			this.Submit.Text = "Submit";
			this.Submit.Click += new System.EventHandler(this.Submit_Click);

			// 
			// status text box
			// 
			this.Status.Location = new System.Drawing.Point(12, 170);
			this.Status.Multiline = false;
			this.Results.Name = "Results";
			this.Status.Size = new System.Drawing.Size(370, 16);
			this.Status.TabIndex = 5;
			this.Status.Text = "";
			this.Status.Enabled = false;
			
			// 
			// Form
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 200);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.TickerLabel,
																		  this.TickerSymbol,
																		  this.ResultLabel,
																		  this.Results,
																		  this.Submit,
																		  this.Status
																		  });
			this.Name = "FinanceService:StockQuoteForm";
			this.Text = "FinanceService:StockQuoteForm";
			this.ResumeLayout(false);

		}
		#endregion

		private void Submit_Click(object sender, System.EventArgs e)
		{
			try
			{
				Button button;
				button = (Button)sender;
				
				this.TickerSymbol.Text = this.TickerSymbol.Text.Trim ().ToUpper ();

				this.Results.Text = "";
				this.Status.Text = "";
				
				double stockQuote = this.fsc.getStockQuote (this.TickerSymbol.Text);

				this.Results.Text = "$" + stockQuote;
				this.Status.Text = "Done.";
			}
			catch (SystemException ex)
			{
				this.Results.Text = "NA";
				this.Status.Text = "Stock quote not available for symbol (" + this.TickerSymbol.Text + ")";
				Console.WriteLine ("*** exceptin: " + ex.ToString ());
			}
		}

	}
	
}
