package com.trcinc.finance;

import com.trcinc.common.FinanceAppException;

/**
 * 
 * Persistence interface
 * 
 * @author sgovind
 *
 */
public interface FinancePersistence
{


	/**
	 * Adds a ticker/price to the persistence store.
	 * 
	 * @param ticker
	 * @param price
	 * @throws FinanceAppException
	 */
	public void addStockQuote (String ticker, double price) throws FinanceAppException;
	
	/**
	 * Returns the stock quote for the ticker.
	 * 
	 * @param ticker
	 * @return double
	 * @throws InvalidTickerException
	 * @throws FinanceAppException
	 */

	public double getStockQuote (String ticker) throws InvalidTickerException, FinanceAppException;
	
}
