package com.trcinc.finance.ws;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.EJBLocalHome;
import javax.ejb.EJBLocalObject;
import javax.ejb.EJBObject;

import com.trcinc.common.AbstractWebService;
import com.trcinc.finance.FinanceServiceHome;
import com.trcinc.finance.FinanceServiceLocal;
import com.trcinc.finance.FinanceServiceLocalHome;

/**
 * This class implements the business methods exposed as web service.
 * 
 * Business methods delegates the call to a Local EJB object, in this
 * case to FinanceService EJB bean.
 * 
 * Note: This class can be generated from the EJB bean implementation
 * with XDoclet extension.
 * 
 */

public class FinanceServiceSoapBindingImpl extends AbstractWebService
{
	/**
	 * Cache key to store the EJB local object on the SOAP session.
	 */
	public static final String SESSION_EJB_LOCAL_OBJ_NAME =
		"article.finance.FinanceServiceSoapBindingImpl.ejbLocalRef";

	/**
	 * Constructor for FinanceServiceSoapBindingImpl.
	 */
	public FinanceServiceSoapBindingImpl()
	{
	}

	/**
	 * Creates the FinanceService EJB local object from the
	 * local home interface.
	 * 
	 * @see com.trcinc.common.AbstractWebService#createLocalEjb(EJBLocalHome)
	 */
	public EJBLocalObject createLocalEjb(EJBLocalHome home)
		throws CreateException
	{
		return ((FinanceServiceLocalHome) home).create();
	}

	/**
	 * Returns the FinanceService local interface.
	 * 
	 * Uses the base class helper method to create the class.
	 * 
	 * @return FinanceServiceLocal
	 * @throws Exception
	 */
	public FinanceServiceLocal getLocalService() throws Exception
	{
		FinanceServiceLocal service = null;
		try
		{
			service =
				(FinanceServiceLocal) getLocalService(FinanceServiceLocalHome.JNDI_NAME,
												FinanceServiceLocalHome.class,
													SESSION_EJB_LOCAL_OBJ_NAME);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			throw e;
		}
		return service;
	}

	/**
	 * Returns the name of the service this soap binding implementation.
	 * 
	 * @return String
	 */
	public String getServiceName()
	{
		return "FinanceService";
	}

	/**
	 * Returns the stock price for the given ticker symbol.
	 * Business method exposed as web service.
	 * 
	 * @param ticker
	 * @return double
	 * @throws Exception
	 */
	public double getStockQuote(String ticker) throws Exception
	{
		String _methodName_ = "getStockQuote";

		authorizeMethodAccess(getServiceName(), _methodName_);

		return getLocalService().getStockQuote(ticker);

	}

}
