package com.trcinc.security;

/**
 * Secure session token acquired during authentication and presented when 
 * accessing any secure service.
 */
public final class SecureSession implements java.io.Serializable
{
	private String id;
	private String sessionId;

	public SecureSession()
	{
	}

	public SecureSession(String id, String sessionId)
	{
		setId(id);
		setSessionId (sessionId);
	}
	
	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}


	public String toString()
	{
		return "id="
			+ id
			+ ", "
			+ "sessionId="
			+ sessionId;
	}


	/**
	 * Returns the sessionId.
	 * @return String
	 */
	public String getSessionId()
	{
		return sessionId;
	}

	/**
	 * Sets the sessionId.
	 * @param sessionId The sessionId to set
	 */
	public void setSessionId(String sessionId)
	{
		this.sessionId = sessionId;
	}

}
