package com.trcinc.security;

/**
 * Base exception type subclassed by all security related exceptions.
 */
public class SecurityException extends Exception 
{

	/**
	 * Constructor for SecurityException.
	 */
	public SecurityException() 
	{
		super();
	}

	/**
	 * Constructor for SecurityException.
	 * @param t Throwable to be wrapped inside SecurityException.
	 */
	public SecurityException(Throwable t)
	{
		super(t);
	}
	
	/**
	 * Constructor for SecurityException.
	 * @param s Message describing exception.
	 */
	public SecurityException(String s) 
	{
		super(s);
	}

	/**
	 * Constructor for SecurityException.
	 * @param s Message describing exception.
	 * @param t Throwable to be wrapped inside SecurityException
	 */
	public SecurityException(String s, Throwable t) 
	{
		super(s, t);
	}

}
